#import "CircleView.h"

@implementation CircleView

- (id)initWithFrame:(NSRect)frameRect
{
   self = [super initWithFrame:frameRect];
   clean = YES; 
   myRect.size.width = myRect.size.height = 10.0; 
   myRect.origin.x = myRect.origin.y = 0.0; 
   return self;
}

- (void)mouseDown:(NSEvent *)theEvent
{
   NSPoint p;
   
   p = [NSEvent mouseLocation]; 
   [xabs setFloatValue: p.x]; 
   [yabs setFloatValue: p.y]; 
   p = [theEvent locationInWindow]; 
   [xwrel setFloatValue: p.x]; 
   [ywrel setFloatValue: p.y]; 
   p = [self convertPoint: p fromView:nil]; 
   [xvrel setFloatValue: p.x]; 
   [yvrel setFloatValue: p.y];    
   
   myRect.origin.x = p.x-5.0; 
   myRect.origin.y = p.y-5.0; 
   [self setNeedsDisplay:YES]; 
}

- (void)drawRect:(NSRect)rect
{
   NSBezierPath *drw; 

   [[NSColor whiteColor] set];
   NSRectFill([self bounds]);
   
   if (!clean) {
      drw = [NSBezierPath bezierPathWithOvalInRect:myRect]; 
      [[NSColor blackColor] set]; 
      [drw stroke]; 
      //[drw release]; 
   }
   else clean = NO; 
}

- (IBAction)clean:(id)sender
{
   clean = YES; 
   [self display]; 
}


@end
